; strncpy
;   AAA=str
;   BBB=014
;   F=
;   O=
; str014.asm

.xlist
INCLUDE CLIBC_16.INC
.list

IFDEF CLIBC_16_EXTERN_PTRS
 IF CLIBC_16_EXTERN_PTRS EQ CLIBC_16_EXTERN_PTRS_YES

CLIBC_16_EXTERN_PTRS_SEG_NAME SEGMENT
EXTERNDEF C p_fn_strncpy:FN_CALL PTR
p_fn_strncpy P_FN_CALL strncpy
EXTERNDEF C p_fn_fc_strncpy:FN_CALL PTR
p_fn_fc_strncpy P_FN_CALL @strncpy
EXTERNDEF C p_fn_strncpy_sss:FN_CALL PTR
p_fn_strncpy_sss P_FN_CALL strncpy_sss
EXTERNDEF C p_fn_fc_strncpy_sss:FN_CALL PTR
p_fn_fc_strncpy_sss P_FN_CALL @strncpy_sss
EXTERNDEF C p_fn_strncpy_dss:FN_CALL PTR
p_fn_strncpy_dss P_FN_CALL strncpy_dss
EXTERNDEF C p_fn_fc_strncpy_dss:FN_CALL PTR
p_fn_fc_strncpy_dss P_FN_CALL @strncpy_dss
CLIBC_16_EXTERN_PTRS_SEG_NAME ENDS

 ENDIF
ENDIF

;strncpy() -- Copy n characters of a  string to another
;char __near * fn_call strncpy(char __near * const, const char __near * const, const size_t);
;GIVEN:
;   p_str1	near pointer, (dest) offset from ds
;   p_str2	near pointer, (source) offset from ds
;   num 	max number of characters to copy
;RETURNS:
;   pointer	near pointer, offset from ds (p_str1)
;NOTES:
;   str1 should be at least n+1 bytes
;   str1 is always null terminated
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
strncpy PROC FN_CALL C USES es si di,
	    p_str1:NEAR16 PTR BYTE, p_str2:NEAR16 PTR BYTE, num:WORD

	    mov ax, ds
	    mov es, ax

	    mov di, [p_str1]	     ;es:DI = p_str1
	    mov si, [p_str2]	     ;ds:SI = p_str2
	    mov cx, [num]	     ;CX = max length

	    cmp si, di
	    jne @@cont
	    mov ax, di
	    jmp @@exit
@@cont:

@@loop:
	    jcxz @@addnull
	    dec cx
	    lods BYTE PTR ds:[si]   ;Load char
	    stos BYTE PTR es:[di]   ;Store char
	    test al,al		    ;Loop while not zero
	    jz @@done
	    jmp	@@loop
@@addnull:
	    ; not part of specs
	    ; add terminating null
	    mov BYTE PTR es:[di], 0
@@done:
	    mov ax, [p_str1]
@@exit:
	    ret
strncpy ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS

;strncpy() -- Copy n characters of a  string to another
; __fastcall
;char __near * __fastcall fn_call strncpy(char __near * const, const char __near * const, const size_t);
; GIVEN
;    BX    p_str1, (dest) offset from ds
;    AX    p_str2, (source) offset from ds
;    DX    num
; RETURNS
;   AX		near pointer, offset from ds (p_str1)
;NOTES:
;   str1 should be at least n+1 bytes
;   str1 is always null terminated
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
@strncpy PROC FN_CALL USES es si di cx dx
	    mov di, bx		;es:di = p_str1
	    mov si, ax		;ds:si = p_str2
	    mov cx, dx		;cx = max length

	    mov ax, ds
	    mov es, ax


	    cmp si, di
	    jne @@cont
	    mov ax, di
	    jmp @@exit
@@cont:

@@loop:
	    jcxz @@addnull
	    dec cx
	    lods BYTE PTR ds:[si]   ;Load char
	    stos BYTE PTR es:[di]   ;Store char
	    test al,al		    ;Loop while not zero
	    jz @@done
	    jmp	@@loop
@@addnull:
	    ; not part of specs
	    ; add terminating null
	    mov BYTE PTR es:[di], 0
@@done:
	    mov ax, bx
@@exit:
	    ret
@strncpy ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS

;strncpy_sss() -- Copy n characters of a string to another
;char __near * fn_call strncpy_sss(char __near * const, const char __near * const, const size_t);
;GIVEN:
;   p_str1	near pointer, (dest) offset from ds
;   p_str2	near pointer, (source) offset from ss
;   num 	max number of characters to copy
;RETURNS:
;   pointer	near pointer, offset from ds (p_str1)
;NOTES:
;   str1 should be at least n+1 bytes
;   str1 is always null terminated
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
strncpy_sss PROC FN_CALL C USES ds es si di,
	    p_str1:NEAR16 PTR BYTE, p_str2:NEAR16 PTR BYTE, num:WORD

	    mov bx, ds
	    mov es, bx
	    mov ax, ss
	    mov ds, ax

	    mov di, [p_str1]	     ;es:DI = p_str1
	    mov si, [p_str2]	     ;ds:SI = p_str2
	    mov cx, [num]	     ;CX = max length

	    cmp ax, bx
	    jne @@cont
	    cmp si, di
	    jne @@cont
	    mov ax, di
	    jmp @@exit
@@cont:

@@loop:
	    jcxz @@addnull
	    dec cx
	    lods BYTE PTR ds:[si]   ;Load char
	    stos BYTE PTR es:[di]   ;Store char
	    test al,al		    ;Loop while not zero
	    jz @@done
	    jmp	@@loop
@@addnull:
	    ; not part of specs
	    ; add terminating null
	    mov BYTE PTR es:[di], 0
@@done:
	    mov ax, [p_str1]
@@exit:
	    ret
strncpy_sss ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS

;strncpy_sss() -- Copy n characters of a string to another
;char __near * __fastcall fn_call strncpy_sss(char __near * const, const char __near * const, const size_t);
; __fastcall
; GIVEN:
;    bx    p_str1, (dest) offset from ds
;    ax    p_str2, (source) offset from ss
;    dx    num
; RETURNS:
;   AX		near pointer, offset from ds (p_str1)
;NOTES:
;   str1 should be at least n+1 bytes
;   str1 is always null terminated
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
@strncpy_sss PROC FN_CALL USES ds es si di cx dx
	    mov di, bx		;es:di = p_str1
	    mov si, ax		;ds:si = p_str2
	    mov cx, dx		;cx = max length

	    mov dx, ds
	    mov es, dx
	    mov ax, ss
	    mov ds, ax


	    cmp ax, dx
	    jne @@cont
	    cmp si, di
	    jne @@cont
	    mov ax, di
	    jmp @@exit
@@cont:

@@loop:
	    jcxz @@addnull
	    dec cx
	    lods BYTE PTR ds:[si]   ;Load char
	    stos BYTE PTR es:[di]   ;Store char
	    test al,al		    ;Loop while not zero
	    jz @@done
	    jmp	@@loop
@@addnull:
	    ; not part of specs
	    ; add terminating null
	    mov BYTE PTR es:[di], 0
@@done:
	    mov ax, bx
@@exit:
	    ret
@strncpy_sss ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS

;strncpy_dss() -- Copy n characters of a string to another
;char __near * fn_call strncpy_dss(char __near * const, const char __near * const, const size_t);
;GIVEN:
;   p_str1	near pointer, (dest) offset from ss
;   p_str2	near pointer, (source) offset from ds
;   num 	max number of characters to copy
;RETURNS:
;   pointer	near pointer, offset from ss (p_str1)
;NOTES:
;   str1 should be at least n+1 bytes
;   str1 is always null terminated
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
strncpy_dss PROC FN_CALL C USES es si di,
	    p_str1:NEAR16 PTR BYTE, p_str2:NEAR16 PTR BYTE, num:WORD

	    mov ax, ss
	    mov es, ax

	    mov di, [p_str1]	     ;es:DI = p_str1
	    mov si, [p_str2]	     ;ds:SI = p_str2
	    mov cx, [num]	     ;CX = max length

	    mov bx, ds
	    cmp ax, bx
	    jne @@cont
	    cmp si, di
	    jne @@cont
	    mov ax, di
	    jmp @@exit
@@cont:

@@loop:
	    jcxz @@addnull
	    dec cx
	    lods BYTE PTR ds:[si]   ;Load char
	    stos BYTE PTR es:[di]   ;Store char
	    test al,al		    ;Loop while not zero
	    jz @@done
	    jmp	@@loop
@@addnull:
	    ; not part of specs
	    ; add terminating null
	    mov BYTE PTR es:[di], 0
@@done:
	    mov ax, [p_str1]
@@exit:
	    ret
strncpy_dss ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS

;strncpy_dss() -- Copy n characters of a string to another
;char __near * __fastcall fn_call strncpy_dss(char __near * const, const char __near * const, const size_t);
; __fastcall
; GIVEN:
;    BX    p_str1, (dest) offset from ss
;    AX    p_str2, (source) offset from ds
;    DX    num
;RETURNS:
;   AX	   near pointer, offset from ss (p_str1)
;NOTES:
;   str1 should be at least n+1 bytes
;   str1 is always null terminated
CLIBC_16_FUNCTION_SEG_NAME SEGMENT
@strncpy_dss PROC FN_CALL USES es si di cx dx
	    mov di, bx		;es:di = p_str1
	    mov si, ax		;ds:si = p_str2
	    mov cx, dx		;cx = max length

	    mov ax, ss
	    mov es, ax


	    mov dx, ds
	    cmp ax, dx
	    jne @@cont
	    cmp si, di
	    jne @@cont
	    mov ax, di
	    jmp @@exit
@@cont:

@@loop:
	    jcxz @@addnull
	    dec cx
	    lods BYTE PTR ds:[si]   ;Load char
	    stos BYTE PTR es:[di]   ;Store char
	    test al,al		    ;Loop while not zero
	    jz @@done
	    jmp	@@loop
@@addnull:
	    ; not part of specs
	    ; add terminating null
	    mov BYTE PTR es:[di], 0
@@done:
	    mov ax, bx
@@exit:
	    ret
@strncpy_dss ENDP
CLIBC_16_FUNCTION_SEG_NAME ENDS
END
